/**
 * pmsg.js
 *
 * Copyright (C) 2005-2006 mxproject. All rights reserved.
 *
 * 2005/12/09 eXgJ
 * 2006/02/20 C^[tF[XύX
 */

function PmsgSender()
{
	this._src = 'dummy.pmsg';
	this._content = '';
	this._plugin_node = null;

	this._is_ie = (navigator.userAgent.indexOf('MSIE') != -1);
}

PmsgSender.prototype.preparePluginNode = function(node_to_appended)
{
	var div = document.createElement('div');
	this._plugin_node = node_to_appended.appendChild(div);
}

PmsgSender.prototype._createPluginNode = function(src, character, msg)
{
	var simplemsg = msg;
	simplemsg = simplemsg.replace(/\r?\n|\r/g, "\n");
	// escape ͋s
	simplemsg = encodeURI(simplemsg);
//	alert(simplemsg);

	var attrValues = {
		src       : src,
		persona   : character,
		simplemsg : simplemsg
	};

	if(this._is_ie)
	{
		// object (for IE)
		var eObject = document.createElement('object');
		eObject.setAttribute('classid',
			'clsid:767F6DE8-C0B9-41E2-8329-3B14D47CD175');
		eObject.setAttribute('codebase', 'AxPerMsg.dll');
		eObject.setAttribute('width', '0');
		eObject.setAttribute('height', '0');
		for(var attrName in attrValues)
		{
			var eParam = document.createElement('param');
			eParam.setAttribute('name', attrName);
			eParam.setAttribute('value', attrValues[attrName]);
			eObject.appendChild(eParam);
		}

		return eObject;
	}

	// embed (for Moz, Fx, Opera)
	var eEmbed = document.createElement('embed');
	eEmbed.setAttribute('type', 'application/x-Personaware-Message');
	eEmbed.setAttribute('width', '0');
	eEmbed.setAttribute('height', '0');
	for(var attrName in attrValues)
	{
		eEmbed.setAttribute(attrName, attrValues[attrName]);
	}

	return eEmbed;
}

PmsgSender.prototype.addContent = function(content)
{
	this._content += content;
}

PmsgSender.prototype.clearContent = function()
{
	this._content = '';
}

PmsgSender.prototype.send = function(target_character)
{
	var node = this._createPluginNode(this._src,
									  target_character,
									  this._content);

	if(this._is_ie)
	{
		// :P
		this._plugin_node.innerHTML = node.outerHTML;
	}
	else
	{
		if(this._plugin_node.firstChild)
		{
			this._plugin_node.removeChild(this._plugin_node.firstChild);
		}
		this._plugin_node.appendChild(node);
	}
}
